#include <neorv32.h>
#define N 28

/**@{*/
/** UART BAUD rate */
#define BAUD_RATE 115200
/**@}*/

int main() {

  // capture all exceptions and give debug info via UART
  // this is not required, but keeps us safe
  neorv32_rte_setup();

  // init UART at default baud rate, no parity bits, no HW flow control
  neorv32_uart0_setup(BAUD_RATE, PARITY_NONE, FLOW_CONTROL_NONE);

  // check available hardware extensions and compare with compiler flags
  neorv32_rte_check_isa(0); // silent = 0 -> show message if isa mismatch

  while (1) { // Keep the program running to wait for 'X'
    // Check if a character is available
    if (neorv32_uart0_available()) {
      char c = neorv32_uart0_getc(); // Read character from UART
     
      // Check if the received character is 'X'
      if (c == 'X') {
		int mat1[N][N];
		int mat2[N][N];

		// Initialize mat1 and mat2 with the row index as the value in each row
		for (int i = 0; i < N; i++) {
		    for (int j = 0; j < N; j++) {
			mat1[i][j] = i + 1;  // Fill mat1 with row number (i + 1)
			mat2[i][j] = i + 1;  // Fill mat2 with row number (i + 1)
		    }
		}
		 
		    int rslt[32][32];
		 
		    neorv32_uart0_puts("Multiplication of given two matrices is:\n\n");
		 
		    for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
			    rslt[i][j] = 0;
		 
			    for (int k = 0; k < N; k++) {
				rslt[i][j] += mat1[i][k] * mat2[k][j];
			    }
		 
			    neorv32_uart0_printf("%d\t", rslt[i][j]);
			}
		 
			neorv32_uart0_puts("\n");
		    }
	    }
    }
}
  return 0;
}
